Public Class frm_Properties
    Private m_Ueberschrift As String = ""
    Private m_PropertyString As String = ""
    Private m_ReadString As String = ""
    Private m_WriteString As String = ""
    'ReadOnly Property PropertyName() As String
    '    Get
    '        Return Me.TextBoxProperty.Text
    '    End Get
    'End Property
    ReadOnly Property Ueberschrift() As String
        Get
            Return m_Ueberschrift
        End Get
    End Property
    ReadOnly Property PropertyString() As String
        Get
            Return m_PropertyString
        End Get
    End Property
    ReadOnly Property IsReadOnly() As Boolean
        Get
            Return Me.CheckBoxReadOnly.Checked
        End Get
    End Property
    ReadOnly Property ReadString() As String
        Get
            Return m_ReadString
        End Get
    End Property
    ReadOnly Property WriteString() As String
        Get
            Return m_WriteString
        End Get
    End Property
    ReadOnly Property IsWriteOnly() As Boolean
        Get
            Return Me.CheckBoxWriteOnly.Checked
        End Get
    End Property

    Private Sub TextBoxProperty_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextBoxProperty.TextChanged
        VollStaendigkeitUeberpruefen()
    End Sub
    Private Sub ComboBoxTyp_TextChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles ComboBoxTyp.TextChanged
        VollStaendigkeitUeberpruefen()
    End Sub

    Private Sub VollStaendigkeitUeberpruefen()
        If TextBoxProperty.Text.Trim <> "" And ComboBoxTyp.Text.Trim <> "" Then
            Me.ButtonOK.Enabled = True
        Else
            Me.ButtonOK.Enabled = False
        End If
    End Sub

    Private Sub ButtonOK_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonOK.Click
        Dim PropText As String = Me.TextBoxProperty.Text.Trim
        Dim PropType As String = Me.ComboBoxTyp.Text.Trim

        Dim StandardValue As String = ""
        Select Case PropType.ToLower
            Case "string"
                StandardValue = Chr(34) & Chr(34)
            Case "integer"
                StandardValue = "0"
            Case "decimal"
                StandardValue = "0R"
            Case "single"
                StandardValue = "0F"
            Case "boolean"
                StandardValue = "False"
            Case "datetime"
                StandardValue = "DateTime.Now"
            Case Else
                StandardValue = "Nothing"
        End Select

        Dim PropString As String = "m_" & PropText


        m_Ueberschrift = "Private " & PropString & " As " & PropType & " = " & StandardValue

        'If PropType = "String" Then
        '    m_Ueberschrift &= " = " & Chr(34) & Chr(34)
        'End If
        m_Ueberschrift &= vbCrLf

        Dim TxtUeberschrift As String = " Property " & PropText & "() As " & PropType & vbCrLf
        'Dim TxtGet As String = "Get" & vbCrLf & _
        '"Return  " & PropString & vbCrLf & "End Get" & vbCrLf
        'Dim TxtSet As String = "Set(ByVal value As " & PropType & ")" & vbCrLf & _
        'PropString & " = value" & vbCrLf & "End Set" & vbCrLf
        m_ReadString = "Return  " & PropString
        m_WriteString = PropString & " = value"

        If CheckBoxReadOnly.Checked Then
            m_PropertyString = "ReadOnly" & TxtUeberschrift '& vbCrLf & TxtGet & vbCrLf & "End Property"
        ElseIf CheckBoxWriteOnly.Checked Then
            m_PropertyString = "WriteOnly" & TxtUeberschrift '& vbCrLf & TxtSet & vbCrLf & "End Property"
        Else
            m_PropertyString = TxtUeberschrift '& vbCrLf & TxtGet & vbCrLf & TxtSet & vbCrLf & "End Property"
        End If
        'm_Ergebnis &= "End Property" & vbCrLf

    End Sub

    Private Checking As Boolean = False
    Private Sub CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CheckBoxReadOnly.CheckedChanged, CheckBoxWriteOnly.CheckedChanged
        If Checking Then Exit Sub
        Checking = True
        If sender Is CheckBoxReadOnly Then
            If CheckBoxReadOnly.Checked Then
                CheckBoxWriteOnly.Checked = False
            End If
        ElseIf sender Is CheckBoxWriteOnly Then
            If CheckBoxWriteOnly.Checked Then
                CheckBoxReadOnly.Checked = False
            End If
        End If
        Checking = False
    End Sub

End Class